/* funktionen wie memcpy, strcpy... bekannt machen: */
#include <string.h>

/* auch die standard funktionen bekannt machen: 	*/
#include <stdlib.h>
#include <stdio.h>

/* Standard TOS funktionen bekannt machen: 			*/

#include <tos.h>
#include <vdi.h>

/* Textbildschirm Funktionen bekannt machen 		*/
/* Diese Datei enthaelt makros (d.h. nichts anderes */
/* als Aliase fuer bestimmte kommandos, wer 		*/
/* interesse hat, was ich meine, schut einmal kurz  */
/* die Datei hinein									*/
#include <screen.h>


/* Ein string konstante definieren: 				*/
/* __DATE__ ist standard und wird vom				*/
/* Compiler auf das aktuelle Datum gesetzt 			*/

#define VERSION 	"0.1 - (" __DATE__ ")"


/* Neue funktion textxy,							*/
/* ------------------------------------------------	*/
/* mit dieser Funktion kann man einen text an einer */
/* bestimmten stelle am Bildschirm ausgeben.		*/
/* Die ersten beiden Parameter bestimmen die 		*/
/* Postion, sie sind vom typ short - das heisste	*/
/* bei purec: 16 bit maximalwert.					*/
/* der parameter inv bestimmt ob schwarz auf weiss	*/
/* oder weiss auf schwarz ausgegeben werden soll	*/
/* der letzte parameter beinhaltet eine 			*/
/* Speicheradresse an die auszugebenden buchstaben 	*/
/* stehen, das ende der buchstaben wird durch ein 	*/
/* null byte markiert. (Uebernimmt der compiler		*/
/* fuer gewoehnlich 								*/
/* Wichtig ist, das diese Funktion ueber main() 	*/
/* ausprogrammiert wird, bzw. vor jeder anderen 	*/
/* funktion in der diese funktin genutzt werden soll*/
/* der compiler kann nur aufrufen was er kennt....  */
/* es gibt auch die moeglichkeit funkt. aufzurfen	*/
/* die nach dem aufruf ausprogrammiert sind.		*/
/* aber das benoetigt eine vorherige "deklaration"	*/
/* - darauf verzichten wir in diesem projekt 		*/

void textxy(short x, short y, short inv, char * str)
{
	/* wenn parameter inv (invertiert) ungleich 0 	*/
	/* ist-dann wird der reverse mode eingeschaltet	*/
	/* d.h. weiss auf schwarze ausgabe 				*/
	if( inv != 0 ) {
		/* Makro das in screen.h definiert wurde: 	*/
		Rev_on();
	}
	/* Jetzt wird der cursor an die gewuenschte 	*/
	/* Stelle gesetzt, diese anweisung ist ebenfalls*/
	/* in screen.h definiert						*/
	Goto_pos( y, x );
	
	/* Diese funktion kennen wir schon: 			*/
	/* wir merken: Cconws gibt immer an der moment. */
	/* cursor-position den text aus.				*/
	Cconws( str );
	
	/* wenn inv ungleich 0 ist, dann wird der 		*/
	/* modus wieder auf normal gesetzt.				*/
	if( inv != 0  ) {
		Rev_off();
	}
}

/* Hauptprogramm, wird aufgerufen nach start des Programms: */
int main(void)
{
	/* Anstatt Cconws rufen wir jetzt 	*/
	/* unsere eigene Textausgabe routine*/
	/* auf! */
	/* Spalte 2, Zeile 10, Invers, Text */

	textxy( 3, 1, 1,"SimpleBoot Version " VERSION );

	
	/* am ende wird nochmal ein Ruecklauf /		 	*/
	/* Zeilenumbruch ausgegeben, damit die Konsole	*/
	/* auf der wir ausgeben "sauber" ist. 			*/
	/* (testet einfach mal was passiert wenn man es */
	/* weglaesst. 									*/

	Cconws("\r\n");

	
	/* da die funktion main() den rueckgabetyp "int"*/
	/* (je nach compiler einstellung 16 oder		*/ 
	/*	32 bit zahl) hat, muss ein entsprechender	*/
	/* wert zurueckgegeben werden - 0 bedeutet: kein*/
	/* fehler. 										*/

	return( 0 );
}

